function SpringyFX_Main(thisObj) {
    function SpringyFX(thisObj) {
        function checkForFile(file) {
            if (!file.exists) {
                var type = file instanceof File ? "file: " : "folder: ";
                alert("Could not find the necessary " + type + file.displayName + "\nPlease reinstall as instructed in the user guide.");
                return false;
            } else {
                return true;
            }
        }

        function detect() {
            var touches = "";
            var keyState = ScriptUI.environment.keyboardState;
            if (keyState.shiftKey) {
                touches += "shift";
            }
            if (keyState.altKey) {
                touches += "alt";
            }
            if (keyState.ctrlKey) {
                touches += "ctrl";
            }
            return touches;
        }

        function SpringConstraint(prefixName, layerID) {
            var myComp = app.project.activeItem;
            var compLayers = myComp.selectedLayers;
            var myDeformedLayer = compLayers[0];
            var presetPath = myAssetsPath + "Spring Constraint pseudo CTRL.ffx";
            var myControler = myComp.layers.addSolid([0.59, 0.667, 0.956], prefixName + " - Spring Constraint CTRL", myComp.width, myComp.height, 1);
            myControler.property("Opacity").setValue(0);
            var myPreset = File(presetPath);
            myControler.applyPreset(myPreset);
            myControler.label = 5;
            myControler.property("ADBE Effect Parade").property("Pseudo/SpringConstraintCTRL").property("Pseudo/SpringConstraintCTRL-0001").setValue(layerID);
            myControler.property("position").expression = "[thisComp.width/2,thisComp.height/2]";
            myControler.property("scale").expression = "[100,100]";
            myControler.property("rotation").expression = "0";
            myControler.enabled = false;
            myControler.select = false;
        }

        function BEND(defName, dim1, dim2) {
            var myComp = app.project.activeItem;
            var compLayers = myComp.selectedLayers;
            var myDeformedLayer = compLayers[0];
            if (compLayers.length > 1) {
                alert("Please select only one layer at the time");
            } else {
                if (myDeformedLayer instanceof ShapeLayer) {
                    alert("Shape layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your vector design.");
                } else {
                    if (myDeformedLayer.property("sourceText") !== null) {
                        alert("Text layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your text design.");
                    } else {
                        if (compLayers.length == 0) {
                            alert("Please select the layer you want to deform");
                        } else {
                            if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL") != null) {
                                try {
                                    function test() {
                                        if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL").effect("Bend X MAX")(1) != null) {
                                            alert("Oops ! Sorry but...\nOne springy " + defName + " deformer already exists on the selected layer !");
                                        }
                                    }
                                    test();
                                } catch (err) {
                                    if (err instanceof ReferenceError) {
                                        var myDeformedLayer = compLayers[0];
                                        var prefixName = myDeformedLayer.name;
                                        var layerID = myDeformedLayer.index + 1;
                                        var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                        var controlX = myControler.Effects.addProperty("ADBE Slider Control");
                                        controlX.name = defName + " " + dim1 + " MAX";
                                        controlX.property(1).setValue(100);
                                        var controlY = myControler.Effects.addProperty("ADBE Slider Control");
                                        controlY.name = defName + " " + dim2 + " MAX";
                                        controlY.property(1).setValue(100);
                                        myControler.selected = false;
                                        var defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                        var myDefPreset = File(defPresetPath);
                                        myDeformedLayer.selected = true;
                                        myDeformedLayer.applyPreset(myDefPreset);
                                    }
                                }
                            } else {
                                var myDeformedLayer = compLayers[0];
                                var presetPath2 = myAssetsPath + "Springy Deformers pseudo CTRL.ffx";
                                var myPreset2 = File(presetPath2);
                                myDeformedLayer.applyPreset(myPreset2);
                                var prefixName = myDeformedLayer.name;
                                var layerID = myDeformedLayer.index + 1;
                                SpringConstraint(prefixName, layerID);
                                var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0001").setValue(myControler.index);
                                var controlX = myControler.Effects.addProperty("ADBE Slider Control");
                                controlX.name = defName + " " + dim1 + " MAX";
                                controlX.property(1).setValue(100);
                                var controlY = myControler.Effects.addProperty("ADBE Slider Control");
                                controlY.name = defName + " " + dim2 + " MAX";
                                controlY.property(1).setValue(100);
                                myControler.selected = false;
                                var defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                var myDefPreset = File(defPresetPath);
                                myDeformedLayer.selected = true;
                                myDeformedLayer.applyPreset(myDefPreset);
                            }
                        }
                    }
                }
            }
        }

        function SHEAR(defName, dim1, dim2) {
            var myComp = app.project.activeItem;
            var compLayers = myComp.selectedLayers;
            var myDeformedLayer = compLayers[0];
            if (compLayers.length > 1) {
                alert("Please select only one layer at the time");
            } else {
                if (myDeformedLayer instanceof ShapeLayer) {
                    alert("Shape layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your vector design.");
                } else {
                    if (myDeformedLayer.property("sourceText") !== null) {
                        alert("Text layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your text design.");
                    } else {
                        if (compLayers.length == 0) {
                            alert("Please select the layer you want to deform");
                        } else {
                            if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL") != null) {
                                try {
                                    function test() {
                                        if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL").effect("Shear X MAX")(1) != null) {
                                            alert("Oops ! Sorry but...\nOne springy " + defName + " deformer already exists on the selected layer !");
                                        }
                                    }
                                    test();
                                } catch (err) {
                                    if (err instanceof ReferenceError) {
                                        var myDeformedLayer = compLayers[0];
                                        var prefixName = myDeformedLayer.name;
                                        var layerID = myDeformedLayer.index + 1;
                                        var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                        var controlX = myControler.Effects.addProperty("ADBE Slider Control");
                                        controlX.name = defName + " " + dim1 + " MAX";
                                        controlX.property(1).setValue(100);
                                        var controlY = myControler.Effects.addProperty("ADBE Slider Control");
                                        controlY.name = defName + " " + dim2 + " MAX";
                                        controlY.property(1).setValue(100);
                                        myControler.selected = false;
                                        var defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                        var myDefPreset = File(defPresetPath);
                                        myDeformedLayer.selected = true;
                                        myDeformedLayer.applyPreset(myDefPreset);
                                    }
                                }
                            } else {
                                var myDeformedLayer = compLayers[0];
                                var presetPath2 = myAssetsPath + "Springy Deformers pseudo CTRL.ffx";
                                var myPreset2 = File(presetPath2);
                                myDeformedLayer.applyPreset(myPreset2);
                                var prefixName = myDeformedLayer.name;
                                var layerID = myDeformedLayer.index + 1;
                                SpringConstraint(prefixName, layerID);
                                var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0001").setValue(myControler.index);
                                var controlX = myControler.Effects.addProperty("ADBE Slider Control");
                                controlX.name = defName + " " + dim1 + " MAX";
                                controlX.property(1).setValue(100);
                                var controlY = myControler.Effects.addProperty("ADBE Slider Control");
                                controlY.name = defName + " " + dim2 + " MAX";
                                controlY.property(1).setValue(100);
                                myControler.selected = false;
                                var defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                var myDefPreset = File(defPresetPath);
                                myDeformedLayer.selected = true;
                                myDeformedLayer.applyPreset(myDefPreset);
                            }
                        }
                    }
                }
            }
        }
        var myComp = app.project.activeItem;
        var myScriptPath = new File($.fileName).parent.fsName;
        var myAssetsPath = myScriptPath + "/SpringyFXassets/";
        var myInfoExp = "// Springy FX - created by Matthieu Fremeaux (aka FREMOX) from MotionCafe \n// more informations on motion-cafe.com and aescripts.com";
        if (!checkForFile(Folder(myAssetsPath))) {
            return;
        }

        function SQUASH_AND_STRETCH(defName, dim1, dim2) {
            var myComp = app.project.activeItem;
            var compLayers = myComp.selectedLayers;
            var myDeformedLayer = compLayers[0];
            if (compLayers.length > 1) {
                alert("Please select only one layer at the time");
            } else {
                if (myDeformedLayer instanceof ShapeLayer) {
                    alert("Shape layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your vector design.");
                } else {
                    if (myDeformedLayer.property("sourceText") !== null) {
                        alert("Text layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your text design.");
                    } else {
                        if (compLayers.length == 0) {
                            alert("Please select the layer you want to deform");
                        } else {
                            if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL") != null) {
                                try {
                                    function test() {
                                        if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL").effect("Squash and Stretch X MAX")(1) != null) {
                                            alert("Oops ! Sorry but...\nOne springy " + defName + " deformer already exists on the selected layer !");
                                        }
                                    }
                                    test();
                                } catch (err) {
                                    if (err instanceof ReferenceError) {
                                        var myDeformedLayer = compLayers[0];
                                        var prefixName = myDeformedLayer.name;
                                        var layerID = myDeformedLayer.index + 1;
                                        var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                        var controlX = myControler.Effects.addProperty("ADBE Slider Control");
                                        controlX.name = defName + " " + dim1 + " MAX";
                                        controlX.property(1).setValue(100);
                                        var controlY = myControler.Effects.addProperty("ADBE Slider Control");
                                        controlY.name = defName + " " + dim2 + " MAX";
                                        controlY.property(1).setValue(100);
                                        myControler.selected = false;
                                        var defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                        var myDefPreset = File(defPresetPath);
                                        myDeformedLayer.selected = true;
                                        myDeformedLayer.applyPreset(myDefPreset);
                                    }
                                }
                            } else {
                                var myDeformedLayer = compLayers[0];
                                var presetPath2 = myAssetsPath + "Springy Deformers pseudo CTRL.ffx";
                                var myPreset2 = File(presetPath2);
                                myDeformedLayer.applyPreset(myPreset2);
                                var prefixName = myDeformedLayer.name;
                                var layerID = myDeformedLayer.index + 1;
                                SpringConstraint(prefixName, layerID);
                                var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0001").setValue(myControler.index);
                                var controlX = myControler.Effects.addProperty("ADBE Slider Control");
                                controlX.name = defName + " " + dim1 + " MAX";
                                controlX.property(1).setValue(100);
                                var controlY = myControler.Effects.addProperty("ADBE Slider Control");
                                controlY.name = defName + " " + dim2 + " MAX";
                                controlY.property(1).setValue(100);
                                myControler.selected = false;
                                var defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                var myDefPreset = File(defPresetPath);
                                myDeformedLayer.selected = true;
                                myDeformedLayer.applyPreset(myDefPreset);
                            }
                        }
                    }
                }
            }
        }

        function JIGGLE(defName) {
            var myComp = app.project.activeItem;
            var compLayers = myComp.selectedLayers;
            var myDeformedLayer = compLayers[0];
            var myJigglinPinExp = "\nspringLayerName=effect('Springy Deformers CTRL')('Spring Constraint Layer').name;\nbaseLayer=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Inherit Motion From');\nspringAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Position XY')-baseLayer.position;\nmyEffectName=thisProperty.propertyGroup(1).name+' pin - Jiggling MAX';\npinRest=thisComp.layer(springLayerName).effect(myEffectName)(1)\nif(thisComp.layer(springLayerName).effect('Activate Jiggle deformer')(1)==1){value+springAmount*(pinRest/100);}else{value}";
            if (compLayers.length > 1) {
                alert("Please select one or more Puppet pins on one single layer at a time");
            } else {
                if (myDeformedLayer instanceof ShapeLayer) {
                    alert("Shape layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your vector design.");
                } else {
                    if (myDeformedLayer.property("sourceText") !== null) {
                        alert("Text layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your text design.");
                    } else {
                        if (compLayers.length == 0) {
                            alert("Please select one layer that contains some Puppet pins on it or some pins on a single layer");
                        } else {
                            if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL") != null) {
                                try {
                                    function test() {
                                        if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL").effect("Activate Jiggle deformer")(1) != null) {
                                            var myDeformedLayer = compLayers[0];
                                            var prefixName = myDeformedLayer.name;
                                            var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                            myDeformedLayer.effect.property("ADBE FreePin3").name = "Jiggle";
                                            var effectsGroup = myDeformedLayer.effect.property("ADBE FreePin3").property("ADBE FreePin3 ARAP Group").property("ADBE FreePin3 Mesh Group").property("ADBE FreePin3 Mesh Atom").property("ADBE FreePin3 PosPins");
                                            var selectedPins = new Array();
                                            var control = new Array();
                                            if (effectsGroup !== null) {
                                                for (var i = 1; i <= effectsGroup.numProperties; i += 1) {
                                                    if (effectsGroup.property(i).selected) {
                                                        selectedPins[selectedPins.length] = effectsGroup.property(i);
                                                    }
                                                }
                                            }
                                            if (selectedPins.length > 0) {
                                                for (var p = 0; p <= selectedPins.length - 1; p += 1) {
                                                    control[p] = myControler.Effects.addProperty("ADBE Slider Control");
                                                    control[p].name = selectedPins[p].name + " pin - Jiggling MAX";
                                                    control[p].property(1).setValue(100);
                                                    selectedPins[p].property("ADBE FreePin3 PosPin Position").expression = myInfoExp + "\n " + myJigglinPinExp;
                                                }
                                                if (selectedPins.length == 1) {
                                                    alert("You have created " + selectedPins.length + " single jiggling pin.");
                                                } else {
                                                    alert("You have created " + selectedPins.length + " jiggling pins.");
                                                }
                                            } else {
                                                var createAllPins = confirm("/!\\ You haven't selected any pins among the " + effectsGroup.numProperties + " ones that exist on this layer. Do you really want to make " + defName.toLowerCase() + " all of them ?\nPlease keep in mind that it will create as many controllers and expressions as the pins count.\nSo the more pins you have on the layer, the slower After Effects will preview and render your project !\n ");
                                                if (createAllPins) {
                                                    for (var n = 1; n <= effectsGroup.numProperties; n += 1) {
                                                        control[n] = myControler.Effects.addProperty("ADBE Slider Control");
                                                        control[n].name = effectsGroup.property(n).name + " pin - Jiggling MAX";
                                                        control[n].property(1).setValue(100);
                                                    }
                                                } else {
                                                    alert("You haven't created any jiggling pin.");
                                                }
                                            }
                                        }
                                    }
                                    test();
                                } catch (err) {
                                    if (err instanceof ReferenceError) {
                                        var myDeformedLayer = compLayers[0];
                                        var prefixName = myDeformedLayer.name;
                                        var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                        myDeformedLayer.effect.property("ADBE FreePin3").name = "Jiggle";
                                        var effectsGroup = myDeformedLayer.effect.property("ADBE FreePin3").property("ADBE FreePin3 ARAP Group").property("ADBE FreePin3 Mesh Group").property("ADBE FreePin3 Mesh Atom").property("ADBE FreePin3 PosPins");
                                        var controlCase = myControler.Effects.addProperty("ADBE Checkbox Control");
                                        controlCase.name = "Activate " + defName + " deformer";
                                        controlCase.property(1).setValue(1);
                                        var selectedPins = new Array();
                                        var control = new Array();
                                        if (effectsGroup !== null) {
                                            for (var i = 1; i <= effectsGroup.numProperties; i += 1) {
                                                if (effectsGroup.property(i).selected) {
                                                    selectedPins[selectedPins.length] = effectsGroup.property(i);
                                                }
                                            }
                                        }
                                        if (selectedPins.length > 0) {
                                            for (var p = 0; p <= selectedPins.length - 1; p += 1) {
                                                control[p] = myControler.Effects.addProperty("ADBE Slider Control");
                                                control[p].name = selectedPins[p].name + " pin - Jiggling MAX";
                                                control[p].property(1).setValue(100);
                                                selectedPins[p].property("ADBE FreePin3 PosPin Position").expression = myInfoExp + "\n " + myJigglinPinExp;
                                            }
                                            if (selectedPins.length == 1) {
                                                alert("You have created " + selectedPins.length + " single jiggling pin.");
                                            } else {
                                                alert("You have created " + selectedPins.length + " jiggling pins.");
                                            }
                                        } else {
                                            var createAllPins = confirm("/!\\ You haven't selected any pins among the " + effectsGroup.numProperties + " ones that exist on this layer. Do you really want to make " + defName.toLowerCase() + " all of them ?\nPlease keep in mind that it will create as many controllers and expressions as the pins count.\nSo the more pins you have on the layer, the slower After Effects will preview and render your project !\n ");
                                            if (createAllPins) {
                                                for (var n = 1; n <= effectsGroup.numProperties; n += 1) {
                                                    control[n] = myControler.Effects.addProperty("ADBE Slider Control");
                                                    control[n].name = effectsGroup.property(n).name + " pin - Jiggling MAX";
                                                    control[n].property(1).setValue(100);
                                                }
                                            } else {
                                                alert("You haven't created any jiggling pin.");
                                            }
                                        }
                                    }
                                }
                            } else {
                                var myDeformedLayer = compLayers[0];
                                var presetPath2 = myAssetsPath + "Springy Deformers pseudo CTRL.ffx";
                                var myPreset2 = File(presetPath2);
                                myDeformedLayer.applyPreset(myPreset2);
                                myDeformedLayer.effect.property("Pseudo/SpringyDeformersCTRL").moveTo(1);
                                myDeformedLayer.effect.property("ADBE FreePin3").name = "Jiggle";
                                var prefixName = myDeformedLayer.name;
                                var layerID = myDeformedLayer.index + 1;
                                SpringConstraint(prefixName, layerID);
                                var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0001").setValue(myControler.index);
                                myDeformedLayer.effect.property("ADBE FreePin3").name = "Jiggle";
                                var effectsGroup = myDeformedLayer.effect.property("ADBE FreePin3").property("ADBE FreePin3 ARAP Group").property("ADBE FreePin3 Mesh Group").property("ADBE FreePin3 Mesh Atom").property("ADBE FreePin3 PosPins");
                                var selectedPins = new Array();
                                var control = new Array();
                                if (effectsGroup !== null) {
                                    for (var i = 1; i <= effectsGroup.numProperties; i += 1) {
                                        if (effectsGroup.property(i).selected) {
                                            selectedPins[selectedPins.length] = effectsGroup.property(i);
                                        }
                                    }
                                }
                                if (selectedPins.length > 0) {
                                    for (var p = 0; p <= selectedPins.length - 1; p += 1) {
                                        control[p] = myControler.Effects.addProperty("ADBE Slider Control");
                                        control[p].name = selectedPins[p].name + " pin - Jiggling MAX";
                                        control[p].property(1).setValue(100);
                                    }
                                    myControler.select = false;
                                    myDeformedLayer.select = true;
                                } else {
                                    var createAllPins = confirm("Do you want to make " + defName.toLowerCase() + " all of the puppet pins (there are " + effectsGroup.numProperties + " of them on the selected layer) ? If you prefer to manually choose the pins to affect, just click on NO.\nPlease keep in mind that it will create as many controllers and expressions as the pins count.\nSo the more pins you have on the layer, the slower After Effects will preview and render your project !\n ");
                                    if (createAllPins) {
                                        var controlCase = myControler.Effects.addProperty("ADBE Checkbox Control");
                                        controlCase.name = "Activate " + defName + " deformer";
                                        controlCase.property(1).setValue(1);
                                        for (var n = 1; n <= effectsGroup.numProperties; n += 1) {
                                            control[n] = myControler.Effects.addProperty("ADBE Slider Control");
                                            control[n].name = effectsGroup.property(n).name + " pin - Jiggling MAX";
                                            control[n].property(1).setValue(100);
                                            effectsGroup.property(n).property("ADBE FreePin3 PosPin Position").expression = myInfoExp + "\n " + myJigglinPinExp;
                                            myControler.select = false;
                                            myDeformedLayer.select = true;
                                        }
                                    } else {
                                        alert("Now select each pin you want to make " + defName.toLowerCase() + ", then click on the " + defName + " button again");
                                        myControler.select = false;
                                        myDeformedLayer.select = true;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        function LIQUID(defName) {
            var myComp = app.project.activeItem;
            var compLayers = myComp.selectedLayers;
            var myDeformedLayer = compLayers[0];
            var myContainerLayer = compLayers[1];
            if (compLayers.length > 2) {
                alert("Please select only 1 or 2 layers at the time");
            } else {
                if (myDeformedLayer instanceof ShapeLayer) {
                    alert("Shape layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your vector design.");
                } else {
                    if (myDeformedLayer.property("sourceText") !== null) {
                        alert("Text layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your text design.");
                    } else {
                        if (compLayers.length == 0) {
                            alert("Please select the layer you want to deform");
                        } else {
                            if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL") != null) {
                                try {
                                    function test() {
                                        if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL").effect("Liquid Rotation MAX")(1) != null) {
                                            alert("Oops ! Sorry but...\nOne springy " + defName + " deformer already exists on the selected layer !");
                                        }
                                    }
                                    test();
                                } catch (err) {
                                    if (err instanceof ReferenceError) {
                                        var myDeformedLayer = compLayers[0];
                                        var myDeformedLayer = compLayers[0];
                                        var myXanchorValue = myDeformedLayer.property("ADBE Transform Group").property("ADBE Anchor Point").value[0];
                                        var myYposValue = myDeformedLayer.property("ADBE Transform Group").property("ADBE Position").value[1];
                                        var myYanchorValue = myDeformedLayer.property("ADBE Transform Group").property("ADBE Anchor Point").value[1];
                                        var myDeltaValue = myYposValue - myYanchorValue;
                                        var touches = detect();
                                        try {
                                            var myDeformedLayer = compLayers[0];
                                            var myContainerLayer = compLayers[1];
                                            myContainerLayer.parent = myDeformedLayer;
                                            myContainerLayer.moveAfter(myDeformedLayer);
                                            var myLiquidMaskLayer = myContainerLayer.duplicate();
                                            myLiquidMaskLayer.moveBefore(myDeformedLayer);
                                            myLiquidMaskLayer.parent = myContainerLayer;
                                            myLiquidMaskLayer.selected = false;
                                            myLiquidMaskLayer.locked = true;
                                            myContainerLayer.selected = false;
                                            myDeformedLayer.selected = true;
                                            myDeformedLayer.trackMatteType = TrackMatteType.ALPHA;
                                        } catch (err) {

                                        }
                                        var presetPath2 = myAssetsPath + "Springy Deformers pseudo CTRL.ffx";
                                        var myPreset2 = File(presetPath2);
                                        myDeformedLayer.applyPreset(myPreset2);
                                        try {
                                            myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0003").setValue(myDeformedLayer.sourceRectAtTime(0, false).width);
                                            myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0004").setValue(myDeformedLayer.sourceRectAtTime(0, false).height);
                                        } catch (err) {
                                            alert("Please enter the estimated size of your Liquid layer in its effect called 'Springy Deformer CTRL' > 'Source Layer Size', for both X and Y dimensions");
                                        }
                                        var myBubblePreset = File(myAssetsPath + "Bubbles_liquid.ffx");
                                        if (touches.indexOf("shift") != -1) {
                                            myDeformedLayer.selected = true;
                                            myDeformedLayer.applyPreset(myBubblePreset);
                                        }
                                        myDeformedLayer.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([myXanchorValue, 0]);
                                        myDeformedLayer.property("ADBE Transform Group").property("ADBE Position").expression = myInfoExp + "\n [value[0],transform.anchorPoint[1]+value[1]-effect('Springy Deformers CTRL')(4)/2]";
                                        var prefixName = myDeformedLayer.name;
                                        var layerID = myDeformedLayer.index + 1;
                                        var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                        var controlRot = myControler.Effects.addProperty("ADBE Angle Control");
                                        controlRot.name = defName + " Rotation MAX";
                                        controlRot.property(1).setValue(45);
                                        var controlTwist = myControler.Effects.addProperty("ADBE Angle Control");
                                        controlTwist.name = defName + " Twist MAX";
                                        controlTwist.property(1).setValue(45);
                                        var controlWAmp = myControler.Effects.addProperty("ADBE Slider Control");
                                        controlWAmp.name = defName + " Waves Amp MAX";
                                        controlWAmp.property(1).setValue(100);
                                        var controlWSize = myControler.Effects.addProperty("ADBE Slider Control");
                                        controlWSize.name = defName + " Waves Size MAX";
                                        controlWSize.property(1).setValue(50);
                                        var controlLevel = myControler.Effects.addProperty("ADBE Slider Control");
                                        controlLevel.name = defName + " Level";
                                        controlLevel.property(1).setValue(0);
                                        myControler.property("ADBE Effect Parade").property("Pseudo/SpringConstraintCTRL").property("Pseudo/SpringConstraintCTRL-0024").setValue(9);
                                        myControler.property("ADBE Effect Parade").property("Pseudo/SpringConstraintCTRL").property("Pseudo/SpringConstraintCTRL-0025").setValue(1);
                                        myControler.selected = false;
                                        var defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                        if (myDeformedLayer instanceof ShapeLayer) {
                                            defPresetPath = myAssetsPath + defName + "_deform_ShapeLayersHack.ffx";
                                        } else {
                                            defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                        }
                                        var myDefPreset = File(defPresetPath);
                                        myDeformedLayer.selected = true;
                                        myDeformedLayer.applyPreset(myDefPreset);
                                    }
                                }
                            } else {
                                var myDeformedLayer = compLayers[0];
                                var myXanchorValue = myDeformedLayer.property("ADBE Transform Group").property("ADBE Anchor Point").value[0];
                                var myYposValue = myDeformedLayer.property("ADBE Transform Group").property("ADBE Position").value[1];
                                var myYanchorValue = myDeformedLayer.property("ADBE Transform Group").property("ADBE Anchor Point").value[1];
                                var myDeltaValue = myYposValue - myYanchorValue;
                                var touches = detect();
                                try {
                                    var myDeformedLayer = compLayers[0];
                                    var myContainerLayer = compLayers[1];
                                    myContainerLayer.parent = myDeformedLayer;
                                    myContainerLayer.moveAfter(myDeformedLayer);
                                    var myLiquidMaskLayer = myContainerLayer.duplicate();
                                    myLiquidMaskLayer.moveBefore(myDeformedLayer);
                                    myLiquidMaskLayer.parent = myContainerLayer;
                                    myLiquidMaskLayer.selected = false;
                                    myLiquidMaskLayer.locked = true;
                                    myContainerLayer.selected = false;
                                    myDeformedLayer.selected = true;
                                    myDeformedLayer.trackMatteType = TrackMatteType.ALPHA;
                                } catch (err) {

                                }
                                var presetPath2 = myAssetsPath + "Springy Deformers pseudo CTRL.ffx";
                                var myPreset2 = File(presetPath2);
                                myDeformedLayer.applyPreset(myPreset2);
                                try {
                                    myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0003").setValue(myDeformedLayer.sourceRectAtTime(0, false).width);
                                    myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0004").setValue(myDeformedLayer.sourceRectAtTime(0, false).height);
                                } catch (err) {
                                    alert("Please enter the estimated size of your Liquid layer in its effect called 'Springy Deformer CTRL' > 'Source Layer Size', for both X and Y dimensions");
                                }
                                var myBubblePreset = File(myAssetsPath + "Bubbles_liquid.ffx");
                                if (touches.indexOf("shift") != -1) {
                                    myDeformedLayer.selected = true;
                                    myDeformedLayer.applyPreset(myBubblePreset);
                                }
                                if (myDeformedLayer instanceof ShapeLayer) {
                                    myDeformedLayer.property("ADBE Transform Group").property("ADBE Anchor Point").expression = myInfoExp + "\n [0,-effect('Springy Deformers CTRL')(4)/2]";
                                    myDeformedLayer.property("ADBE Transform Group").property("ADBE Position").expression = myInfoExp + "\n [value[0],transform.anchorPoint[1]+value[1]]";
                                } else {
                                    myDeformedLayer.property("ADBE Transform Group").property("ADBE Anchor Point").setValue([myXanchorValue, 0]);
                                    myDeformedLayer.property("ADBE Transform Group").property("ADBE Position").expression = myInfoExp + "\n [value[0],transform.anchorPoint[1]+value[1]-effect('Springy Deformers CTRL')(4)/2]";
                                }
                                var prefixName = myDeformedLayer.name;
                                var layerID = myDeformedLayer.index + 1;
                                SpringConstraint(prefixName, layerID);
                                var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0001").setValue(myControler.index);
                                var controlRot = myControler.Effects.addProperty("ADBE Angle Control");
                                controlRot.name = defName + " Rotation MAX";
                                controlRot.property(1).setValue(45);
                                var controlTwist = myControler.Effects.addProperty("ADBE Angle Control");
                                controlTwist.name = defName + " Twist MAX";
                                controlTwist.property(1).setValue(45);
                                var controlWAmp = myControler.Effects.addProperty("ADBE Slider Control");
                                controlWAmp.name = defName + " Waves Amp MAX";
                                controlWAmp.property(1).setValue(100);
                                var controlWSize = myControler.Effects.addProperty("ADBE Slider Control");
                                controlWSize.name = defName + " Waves Size MAX";
                                controlWSize.property(1).setValue(50);
                                var controlLevel = myControler.Effects.addProperty("ADBE Slider Control");
                                controlLevel.name = defName + " Level";
                                controlLevel.property(1).setValue(0);
                                myControler.property("ADBE Effect Parade").property("Pseudo/SpringConstraintCTRL").property("Pseudo/SpringConstraintCTRL-0024").setValue(9);
                                myControler.property("ADBE Effect Parade").property("Pseudo/SpringConstraintCTRL").property("Pseudo/SpringConstraintCTRL-0025").setValue(1);
                                myControler.selected = false;
                                var defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                if (myDeformedLayer instanceof ShapeLayer) {
                                    defPresetPath = myAssetsPath + defName + "_deform_ShapeLayersHack.ffx";
                                } else {
                                    defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                }
                                var myDefPreset = File(defPresetPath);
                                myDeformedLayer.selected = true;
                                myDeformedLayer.applyPreset(myDefPreset);
                            }
                        }
                    }
                }
            }
        }

        function BULGE(defName, dim1, dim2) {
            var myComp = app.project.activeItem;
            var compLayers = myComp.selectedLayers;
            var myDeformedLayer = compLayers[0];
            if (compLayers.length > 1) {
                alert("Please select only one layer at the time");
            } else {
                if (myDeformedLayer instanceof ShapeLayer) {
                    alert("Shape layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your vector design.");
                } else {
                    if (myDeformedLayer.property("sourceText") !== null) {
                        alert("Text layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your text design.");
                    } else {
                        if (compLayers.length == 0) {
                            alert("Please select the layer you want to deform");
                        } else {
                            if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL") != null) {
                                try {
                                    function test() {
                                        if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL").effect("Bulge X MAX")(1) != null) {
                                            alert("Oops ! Sorry but...\nOne springy " + defName + " deformer already exists on the selected layer !");
                                        }
                                    }
                                    test();
                                } catch (err) {
                                    if (err instanceof ReferenceError) {
                                        var myDeformedLayer = compLayers[0];
                                        var prefixName = myDeformedLayer.name;
                                        var layerID = myDeformedLayer.index + 1;
                                        var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                        var controlX = myControler.Effects.addProperty("ADBE Slider Control");
                                        controlX.name = defName + " " + dim1 + " MAX";
                                        controlX.property(1).setValue(100);
                                        var controlY = myControler.Effects.addProperty("ADBE Slider Control");
                                        controlY.name = defName + " " + dim2 + " MAX";
                                        controlY.property(1).setValue(100);
                                        myControler.selected = false;
                                        var defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                        var myDefPreset = File(defPresetPath);
                                        myDeformedLayer.selected = true;
                                        myDeformedLayer.applyPreset(myDefPreset);
                                    }
                                }
                            } else {
                                var myDeformedLayer = compLayers[0];
                                var presetPath2 = myAssetsPath + "Springy Deformers pseudo CTRL.ffx";
                                var myPreset2 = File(presetPath2);
                                myDeformedLayer.applyPreset(myPreset2);
                                var prefixName = myDeformedLayer.name;
                                var layerID = myDeformedLayer.index + 1;
                                SpringConstraint(prefixName, layerID);
                                var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0001").setValue(myControler.index);
                                var controlX = myControler.Effects.addProperty("ADBE Slider Control");
                                controlX.name = defName + " " + dim1 + " MAX";
                                controlX.property(1).setValue(100);
                                var controlY = myControler.Effects.addProperty("ADBE Slider Control");
                                controlY.name = defName + " " + dim2 + " MAX";
                                controlY.property(1).setValue(100);
                                myControler.selected = false;
                                var defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                var myDefPreset = File(defPresetPath);
                                myDeformedLayer.selected = true;
                                myDeformedLayer.applyPreset(myDefPreset);
                            }
                        }
                    }
                }
            }
        }

        function TWIST(defName) {
            var myComp = app.project.activeItem;
            var compLayers = myComp.selectedLayers;
            var myDeformedLayer = compLayers[0];
            if (compLayers.length > 1) {
                alert("Please select only one layer at the time");
            } else {
                if (myDeformedLayer instanceof ShapeLayer) {
                    alert("Shape layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your vector design.");
                } else {
                    if (myDeformedLayer.property("sourceText") !== null) {
                        alert("Text layers can not be deformed correctly with Springy FX. Please precompose it before using this tool, and make sure your precomp's size fits as closely as possible the bounding box of your text design.");
                    } else {
                        if (compLayers.length == 0) {
                            alert("Please select the layer you want to deform");
                        } else {
                            if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL") != null) {
                                try {
                                    function test() {
                                        if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL").effect("Twist MAX")(1) != null) {
                                            alert("Oops ! Sorry but...\nOne springy " + defName + " deformer already exists on the selected layer !");
                                        }
                                    }
                                    test();
                                } catch (err) {
                                    if (err instanceof ReferenceError) {
                                        var myDeformedLayer = compLayers[0];
                                        var prefixName = myDeformedLayer.name;
                                        var layerID = myDeformedLayer.index + 1;
                                        var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                        var control = myControler.Effects.addProperty("ADBE Angle Control");
                                        control.name = defName + " MAX";
                                        control.property(1).setValue(360);
                                        myControler.selected = false;
                                        var defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                        var myDefPreset = File(defPresetPath);
                                        myDeformedLayer.selected = true;
                                        myDeformedLayer.applyPreset(myDefPreset);
                                    }
                                }
                            } else {
                                var myDeformedLayer = compLayers[0];
                                var presetPath2 = myAssetsPath + "Springy Deformers pseudo CTRL.ffx";
                                var myPreset2 = File(presetPath2);
                                myDeformedLayer.applyPreset(myPreset2);
                                var prefixName = myDeformedLayer.name;
                                var layerID = myDeformedLayer.index + 1;
                                SpringConstraint(prefixName, layerID);
                                var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0001").setValue(myControler.index);
                                try {
                                    myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0003").setValue(myDeformedLayer.sourceRectAtTime(0, false).width);
                                    myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0004").setValue(myDeformedLayer.sourceRectAtTime(0, false).height);
                                } catch (err) {
                                    var myEnteredSize = prompt("Please enter the size of your source layer, on both dimensions (must be two numbers separated by a comma, as shown in the example below) :", "250,250");
                                    myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0003").setValue(myEnteredSize.split(",")[0]);
                                    myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0004").setValue(myEnteredSize.split(",")[1]);
                                }
                                var control = myControler.Effects.addProperty("ADBE Angle Control");
                                control.name = defName + " MAX";
                                control.property(1).setValue(360);
                                myControler.selected = false;
                                var defPresetPath = myAssetsPath + defName + "_deform.ffx";
                                var myDefPreset = File(defPresetPath);
                                myDeformedLayer.selected = true;
                                myDeformedLayer.applyPreset(myDefPreset);
                            }
                        }
                    }
                }
            }
        }

        function PARENT(defName) {
            var myComp = app.project.activeItem;
            var compLayers = myComp.selectedLayers;
            var myDeformedLayer = compLayers[0];
            var myMasterLayer = compLayers[1];
            if (compLayers.length > 2) {
                alert("Please select only two layers at the time");
            } else {
                if (compLayers.length == 0) {
                    alert("Please select 2 layers : the child has to be selected first, then select the parent that you want your child to follow");
                } else {
                    if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL") != null) {
                        try {
                            function test() {
                                if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL").effect("Springy Parent CTRL")("Pseudo/SpringyParentCTRL-0012") != null) {
                                    alert("Oops ! Sorry but...\nOne springy " + defName + " constraint already exists on the selected layer !");
                                }
                            }
                            test();
                        } catch (err) {
                            if (err instanceof ReferenceError) {
                                var myDeformedLayer = compLayers[0];
                                if (compLayers.length == 1) {
                                    var myMasterLayer = compLayers[0];
                                } else {
                                    var myMasterLayer = compLayers[1];
                                }
                                var myOriginalPosX = myDeformedLayer.property("ADBE Transform Group").property("ADBE Position").value[0];
                                var myOriginalPosY = myDeformedLayer.property("ADBE Transform Group").property("ADBE Position").value[1];
                                var myOriginalPosZ = myDeformedLayer.property("ADBE Transform Group").property("ADBE Position").value[2];
                                var prefixName = myDeformedLayer.name;
                                var layerID = myDeformedLayer.index + 1;
                                var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                myControler.property("ADBE Effect Parade").property("Pseudo/SpringConstraintCTRL").property("Pseudo/SpringConstraintCTRL-0001").setValue(myMasterLayer.index);
                                var control = myControler.Effects.addProperty("Pseudo/SpringyParentCTRL");
                                myControler.selected = false;
                                if (myDeformedLayer.threeDLayer = true) {
                                    var defPresetPath = myAssetsPath + defName + "_3D_constraint.ffx";
                                } else {
                                    var defPresetPath = myAssetsPath + defName + "_constraint.ffx";
                                }
                                var myDefPreset = File(defPresetPath);
                                myDeformedLayer.selected = true;
                                myDeformedLayer.applyPreset(myDefPreset);
                                myControler.property("ADBE Effect Parade").property("Pseudo/SpringyParentCTRL").property("Pseudo/SpringyParentCTRL-0002").setValue([myOriginalPosX, myOriginalPosY]);
                                myControler.property("ADBE Effect Parade").property("Pseudo/SpringyParentCTRL").property("Pseudo/SpringyParentCTRL-0003").setValue(myOriginalPosZ);
                                if (myDeformedLayer.property("ADBE Effect Parade").property(1).matchName == "Pseudo/400fuID/RubberHose") {
                                    var hackPresetPath = myAssetsPath + "RubberHose_rotationHack.ffx";
                                    var myHackPreset = File(hackPresetPath);
                                    myDeformedLayer.selected = true;
                                    myDeformedLayer.applyPreset(myHackPreset);
                                } else {
                                    myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").moveTo(1);
                                }
                            }
                        }
                    } else {
                        var myDeformedLayer = compLayers[0];
                        if (compLayers.length == 1) {
                            var myMasterLayer = compLayers[0];
                        } else {
                            var myMasterLayer = compLayers[1];
                        }
                        var myOriginalPosX = myDeformedLayer.property("ADBE Transform Group").property("ADBE Position").value[0];
                        var myOriginalPosY = myDeformedLayer.property("ADBE Transform Group").property("ADBE Position").value[1];
                        var myOriginalPosZ = myDeformedLayer.property("ADBE Transform Group").property("ADBE Position").value[2];
                        var presetPath2 = myAssetsPath + "Springy Deformers pseudo CTRL.ffx";
                        var myPreset2 = File(presetPath2);
                        myDeformedLayer.applyPreset(myPreset2);
                        var prefixName = myDeformedLayer.name;
                        var layerID = myDeformedLayer.index + 1;
                        SpringConstraint(prefixName, layerID);
                        var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                        myControler.property("ADBE Effect Parade").property("Pseudo/SpringConstraintCTRL").property("Pseudo/SpringConstraintCTRL-0001").setValue(myMasterLayer.index);
                        myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0001").setValue(myControler.index);
                        var control = myControler.Effects.addProperty("Pseudo/SpringyParentCTRL");
                        myControler.selected = false;
                        if (myDeformedLayer.threeDLayer = true) {
                            var defPresetPath = myAssetsPath + defName + "_3D_constraint.ffx";
                        } else {
                            var defPresetPath = myAssetsPath + defName + "_constraint.ffx";
                        }
                        var myDefPreset = File(defPresetPath);
                        myDeformedLayer.selected = true;
                        myDeformedLayer.applyPreset(myDefPreset);
                        myControler.property("ADBE Effect Parade").property("Pseudo/SpringyParentCTRL").property("Pseudo/SpringyParentCTRL-0002").setValue([myOriginalPosX, myOriginalPosY]);
                        myControler.property("ADBE Effect Parade").property("Pseudo/SpringyParentCTRL").property("Pseudo/SpringyParentCTRL-0003").setValue(myOriginalPosZ);
                        if (myDeformedLayer.property("ADBE Effect Parade").property(1).matchName == "Pseudo/400fuID/RubberHose") {
                            var hackPresetPath = myAssetsPath + "RubberHose_rotationHack.ffx";
                            var myHackPreset = File(hackPresetPath);
                            myDeformedLayer.selected = true;
                            myDeformedLayer.applyPreset(myHackPreset);
                        } else {
                            myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").moveTo(1);
                        }
                    }
                }
            }
        }

        function CUSTOM(defName) {
            var myComp = app.project.activeItem;
            var compLayers = myComp.selectedLayers;
            var myDeformedLayer = compLayers[0];
            var parameters = myDeformedLayer.selectedProperties;
            var myEffect = parameters[0];
            var myParameter = parameters[1];
            if (compLayers.length > 1) {
                alert("Please select only one single property at the time in the layer's Effect");
            } else {
                if (compLayers.length == 0) {
                    alert("Hey ! You haven't selected any layer's property, so... how could the script do its magic ?");
                } else {
                    if (parameters.length == 0) {
                        alert("Please select one Effect's property on the layer of your choice");
                    } else {
                        if (!myEffect.isEffect) {
                            alert("Oops ! This property isn't an Effect's one ! Please select only one Effect's property for this feature to work");
                        } else {
                            if (myEffect.isEffect && parameters.length == 1) {
                                alert("Hey ! You can't customize a whole Effect ! Please select only one of its properties");
                            } else {
                                if (myEffect.isEffect && parameters.length > 2) {
                                    alert("Please select only one single property at the time in the layer's Effect");
                                } else {
                                    if (myParameter.propertyValueType == PropertyValueType.TwoD || myParameter.propertyValueType == PropertyValueType.TwoD_SPATIAL || myParameter.propertyValueType == PropertyValueType.ThreeD || myParameter.propertyValueType == PropertyValueType.ThreeD_SPATIAL || myParameter.propertyValueType == PropertyValueType.COLOR || myParameter.propertyValueType == PropertyValueType.NO_VALUE || myParameter.propertyValueType == PropertyValueType.CUSTOM_VALUE || myParameter.isInterpolationTypeValid(KeyframeInterpolationType.LINEAR) == false) {
                                        alert("This is not a supported kind of property ! Please select a numeric property that only has one single dimension");
                                    } else {
                                        if (myComp.layer(compLayers[0].name + " - Spring Constraint CTRL") != null) {
                                            var myDeformedLayer = compLayers[0];
                                            var parameters = myDeformedLayer.selectedProperties;
                                            var myEffect = parameters[0];
                                            var myParameter = parameters[1];
                                            var myEffectName = myEffect.name;
                                            var myPropName = myParameter.name;
                                            var myPropVal = myParameter.value;
                                            var touches = detect();
                                            var prefixName = myDeformedLayer.name;
                                            var layerID = myDeformedLayer.index + 1;
                                            var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                            myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0001").setValue(myControler.index);
                                            if (touches.indexOf("shift") != -1) {
                                                myCustomEffect = prompt("Enter the name of your custom control and its default value, separated by a comma", "My custom control example,100");
                                            } else {
                                                myCustomEffect = myEffectName + " : " + myPropName + "," + myPropVal;
                                            }
                                            var control = myControler.Effects.addProperty("Pseudo/CustomSpringyFXCTRL");
                                            control.name = myCustomEffect.split(",")[0] + " MAX";
                                            control.property(1).setValue(parseInt(myCustomEffect.split(",")[1]));
                                            myControler.selected = false;
                                            var myTextRetrieve = "myDeformedLayer.effect.property('" + myEffectName + "').property('" + myPropName + "').selected=true";
                                            var textLayer = myComp.layers.addText(myTextRetrieve);
                                            textLayer.remove();
                                            eval(myTextRetrieve);
                                            var myComp = app.project.activeItem;
                                            var compLayers = myComp.selectedLayers;
                                            var myDeformedLayer = compLayers[0];
                                            var parameters = myDeformedLayer.selectedProperties;
                                            var myEffect = parameters[0];
                                            var myParameter = parameters[1];
                                            if (myDeformedLayer.threeDLayer == true) {
                                                var kindOfProp = prompt("Which animated property do you want your custom effect to be based on ? Type one of the following entries (only the first letters in uppercase without any space) :\nPX = Position on X axis\nPY = Position on Y axis\nPZ = Position on Z axis\nSX = Scale on X axis\nSY = Scale on Y axis\nSZ = Scale on Z axis\nRX = Rotation on X axis\nRY = Rotation on Y axis\nRZ = Rotation on Z axis", "PX");
                                            } else {
                                                var kindOfProp = prompt("Which animated property do you want your custom effect to be based on ? Type one of the following entries (only the first letters in uppercase without any space) :\nPX = Position on X axis\nPY = Position on Y axis\nSX = Scale on X axis\nSY = Scale on Y axis\nR = Rotation", "PX");
                                            }
                                            switch (kindOfProp) {
                                                case "PX":
                                                case "px":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Position XY')[0]-baseLayer.position[0];";
                                                    var minMaxInput = "thisComp.width";
                                                    break;
                                                case "PY":
                                                case "py":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Position XY')[1]-baseLayer.position[1];";
                                                    var minMaxInput = "thisComp.height";
                                                    break;
                                                case "PZ":
                                                case "pz":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Position Z')-baseLayer.position[2];";
                                                    var minMaxInput = "1000";
                                                    break;
                                                case "SX":
                                                case "sx":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Scale X')-baseLayer.scale[0];";
                                                    var minMaxInput = "100";
                                                    break;
                                                case "SY":
                                                case "sy":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Scale Y')-baseLayer.scale[1];";
                                                    var minMaxInput = "100";
                                                    break;
                                                case "SZ":
                                                case "sz":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Scale Z')-baseLayer.scale[2];";
                                                    var minMaxInput = "100";
                                                    break;
                                                case "RX":
                                                case "rx":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Rotation X')-baseLayer.transform.xRotation;";
                                                    var minMaxInput = "360";
                                                    break;
                                                case "RY":
                                                case "ry":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Rotation Y')-baseLayer.transform.yRotation;";
                                                    var minMaxInput = "360";
                                                    break;
                                                case "RZ":
                                                case "rz":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Rotation Z')-baseLayer.transform.zRotation;";
                                                    var minMaxInput = "360";
                                                    break;
                                                case "R":
                                                case "r":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Rotation Z')-baseLayer.rotation;";
                                                    var minMaxInput = "360";
                                                    break;
                                                case "P":
                                                case "p":
                                                case "S":
                                                case "s":
                                                    alert("You must specify on which axis you want to analyse the layer's motion too. Please undo and retry");
                                                default:
                                                    alert("You didn't typed any correct entry. Please undo and retry");
                                            }
                                            var myCustomExpr = "\nspringLayerName=effect('Springy Deformers CTRL')('Spring Constraint Layer').name;\nbaseLayer=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Inherit Motion From');\nif(thisComp.layer(springLayerName).effect('" + control.name + "')(2)==true){invertCase=-1;}else{invertCase=1;};\n" + springAmount + "\nif(thisComp.layer(springLayerName).effect('" + control.name + "')(3)==true){defAmount= Math.abs(springAmount);}else{defAmount=springAmount;};\nMinInput=-" + minMaxInput + ";\nMaxInput=" + minMaxInput + ";\nMinOutput=-thisComp.layer(springLayerName).effect('" + control.name + "')(1);\nMaxOutput=thisComp.layer(springLayerName).effect('" + control.name + "')(1);\nif(Math.abs(defAmount)>0.1){linear(invertCase*defAmount,MinInput, MaxInput, MinOutput, MaxOutput)+value;}else{value}";
                                            myParameter.expression = myInfoExp + "\n" + myCustomExpr;
                                        } else {
                                            var myDeformedLayer = compLayers[0];
                                            var parameters = myDeformedLayer.selectedProperties;
                                            var myEffect = parameters[0];
                                            var myParameter = parameters[1];
                                            var myEffectName = myEffect.name;
                                            var myPropName = myParameter.name;
                                            var myPropVal = myParameter.value;
                                            var touches = detect();
                                            var presetPath2 = myAssetsPath + "Springy Deformers pseudo CTRL.ffx";
                                            var myPreset2 = File(presetPath2);
                                            myDeformedLayer.applyPreset(myPreset2);
                                            myDeformedLayer.effect.property("Pseudo/SpringyDeformersCTRL").moveTo(1);
                                            var prefixName = myDeformedLayer.name;
                                            var layerID = myDeformedLayer.index + 1;
                                            SpringConstraint(prefixName, layerID);
                                            var myControler = myComp.layer(prefixName + " - Spring Constraint CTRL");
                                            myDeformedLayer.property("ADBE Effect Parade").property("Pseudo/SpringyDeformersCTRL").property("Pseudo/SpringyDeformersCTRL-0001").setValue(myControler.index);
                                            if (touches.indexOf("shift") != -1) {
                                                myCustomEffect = prompt("Enter the name of your custom control and its default value, separated by a comma", "My custom control example,100");
                                            } else {
                                                myCustomEffect = myEffectName + " : " + myPropName + "," + myPropVal;
                                            }
                                            var control = myControler.Effects.addProperty("Pseudo/CustomSpringyFXCTRL");
                                            control.name = myCustomEffect.split(",")[0] + " MAX";
                                            control.property(1).setValue(parseInt(myCustomEffect.split(",")[1]));
                                            myControler.selected = false;
                                            var myTextRetrieve = "myDeformedLayer.effect.property('" + myEffectName + "').property('" + myPropName + "').selected=true";
                                            var textLayer = myComp.layers.addText(myTextRetrieve);
                                            textLayer.remove();
                                            eval(myTextRetrieve);
                                            var myComp = app.project.activeItem;
                                            var compLayers = myComp.selectedLayers;
                                            var myDeformedLayer = compLayers[0];
                                            var parameters = myDeformedLayer.selectedProperties;
                                            var myEffect = parameters[0];
                                            var myParameter = parameters[1];
                                            if (myDeformedLayer.threeDLayer == true) {
                                                var kindOfProp = prompt("Which animated property do you want your custom effect to be based on ? Type one of the following entries (only the first letters in uppercase without any space) :\nPX = Position on X axis\nPY = Position on Y axis\nPZ = Position on Z axis\nSX = Scale on X axis\nSY = Scale on Y axis\nSZ = Scale on Z axis\nRX = Rotation on X axis\nRY = Rotation on Y axis\nRZ = Rotation on Z axis", "PX");
                                            } else {
                                                var kindOfProp = prompt("Which animated property do you want your custom effect to be based on ? Type one of the following entries (only the first letters in uppercase without any space) :\nPX = Position on X axis\nPY = Position on Y axis\nSX = Scale on X axis\nSY = Scale on Y axis\nR = Rotation", "PX");
                                            }
                                            switch (kindOfProp) {
                                                case "PX":
                                                case "px":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Position XY')[0]-baseLayer.position[0];";
                                                    var minMaxInput = "thisComp.width";
                                                    break;
                                                case "PY":
                                                case "py":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Position XY')[1]-baseLayer.position[1];";
                                                    var minMaxInput = "thisComp.height";
                                                    break;
                                                case "PZ":
                                                case "pz":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Position Z')-baseLayer.position[2];";
                                                    var minMaxInput = "1000";
                                                    break;
                                                case "SX":
                                                case "sx":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Scale X')-baseLayer.scale[0];";
                                                    var minMaxInput = "100";
                                                    break;
                                                case "SY":
                                                case "sy":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Scale Y')-baseLayer.scale[1];";
                                                    var minMaxInput = "100";
                                                    break;
                                                case "SZ":
                                                case "sz":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Scale Z')-baseLayer.scale[2];";
                                                    var minMaxInput = "100";
                                                    break;
                                                case "RX":
                                                case "rx":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Rotation X')-baseLayer.transform.xRotation;";
                                                    var minMaxInput = "360";
                                                    break;
                                                case "RY":
                                                case "ry":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Rotation Y')-baseLayer.transform.yRotation;";
                                                    var minMaxInput = "360";
                                                    break;
                                                case "RZ":
                                                case "rz":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Rotation Z')-baseLayer.transform.zRotation;";
                                                    var minMaxInput = "360";
                                                    break;
                                                case "R":
                                                case "r":
                                                    var springAmount = "springAmount=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Springy Rotation Z')-baseLayer.rotation;";
                                                    var minMaxInput = "360";
                                                    break;
                                                case "P":
                                                case "p":
                                                case "S":
                                                case "s":
                                                    alert("You must specify on which axis you want to analyse the layer's motion too. Please undo and retry");
                                                default:
                                                    alert("You didn't typed any correct entry. Please undo and retry");
                                            }
                                            var myCustomExpr = "\nspringLayerName=effect('Springy Deformers CTRL')('Spring Constraint Layer').name;\nbaseLayer=thisComp.layer(springLayerName).effect('Spring Constraint CTRL')('Inherit Motion From');\nif(thisComp.layer(springLayerName).effect('" + control.name + "')(2)==true){invertCase=-1;}else{invertCase=1;};\n" + springAmount + "\nif(thisComp.layer(springLayerName).effect('" + control.name + "')(3)==true){defAmount= Math.abs(springAmount);}else{defAmount=springAmount;};\nMinInput=-" + minMaxInput + ";\nMaxInput=" + minMaxInput + ";\nMinOutput=-thisComp.layer(springLayerName).effect('" + control.name + "')(1);\nMaxOutput=thisComp.layer(springLayerName).effect('" + control.name + "')(1);\nif(Math.abs(defAmount)>0.1){linear(invertCase*defAmount,MinInput, MaxInput, MinOutput, MaxOutput)+value;}else{value}";
                                            myParameter.expression = myInfoExp + "\n" + myCustomExpr;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        function HELP_AND_INFO() {
            alert("Help and informations\n____________________________ \n \nSpringy FX version 1.01\n____________________________ \n\n" + "MONTER AECLUB" + " \n ____________________________\n\nSelect any layer (the 'Parent constraint' and the 'Liquid deformer' can have 2 layers selected), and click on one of the 9 tools to create a nice springy delayed effect !\n \nYou'll find some useful controls on the newly created 'Your selected layer - Springy constraint CTRL' layer, like 'Elasticity', 'Damping' and 'Delay', to customize the springiness of the effect.\n \nNote that you can then choose a different layer in the 'inherit motion from' dropdown list, to make your layer springy follow the positions, scale and rotation of another layer that the original one.\n____________________________ \n \nSpecial shortcuts :  \n  \n[ALT]+click on any button = shows an helpful summary of what the choosen tool is doing and how it works basically ;\n\n[SHIFT]+click = for the 'Liquid deformer', allows you to create a cool bubble effect ; for the 'Custom effect', allows you to rename the custom control and to set up its MAX value ; \n____________________________ \n  \nAdditional information :  \n  \nFor more information (tips, video tutorials, help...), \nplease visit the product's webpage on aescripts.com/springy-fx \nScript and presets created by Matthieu Fremeaux \n(aka FREMOX) - Copyright (c) 2017 \nDo not redistribute without permission. \n ");
        }
        var mainPalette = thisObj instanceof Panel ? thisObj : new Window("palette", scriptName, undefined, {resizeable: true});
        if (mainPalette === null) {
            return;
        }
        mainPalette.alignChildren = ["left", "top"];
        mainPalette.margins = 2;
        mainPalette.spacing = 2;
        var items = ["PARENT", "BEND", "SHEAR", "SQUASH_AND_STRETCH", "JIGGLE", "BULGE", "TWIST", "LIQUID", "CUSTOM", "HELP_AND_INFO"];
        mainPalette.alignChildren = ["fill", "fill"];
        mainPalette.orientation = "stack";
        var content = mainPalette.add("group");
        content.alignChildren = ["fill", "fill"];
        content.orientation = mainPalette.size.width > mainPalette.size.height ? "row" : "column";
        content.margins = 0;
        content.spacing = 2;
        var content2 = mainPalette.add("group");
        content2.alignChildren = ["fill", "fill"];
        content2.orientation = mainPalette.size.width > mainPalette.size.height ? "row" : "column";
        content2.margins = 0;
        content2.spacing = 2;
        var btn = [];
        for (var j = 0; j < items.length; j += 1) {
            btn[j] = content.add("iconbutton", undefined, File(myAssetsPath + items[j] + "_icon.png"));
            btn[j].helpTip = items[j].split("_").join(" ");
        }
        var btn2 = [];
        for (var k = 0; k < items.length; k += 1) {
            btn2[k] = content2.add("iconbutton", undefined, File(myAssetsPath + items[k] + "_icon_L.png"));
            btn2[k].helpTip = items[k].split("_").join(" ");
        }
        btn[0].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("PARENT Constraint\nThe selected layer will follow its own keyframed motion or the motion from another layer (if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'), with a nice elastic delay.\n\nIf you want to keep the orginal motion from the selected layer as the source for the springy motion, just select this animated layer, then click the button.\n\nBut if you want to make a 'child' layer springy follow the motion from a 'parent' layer (DO NOT use the AE's parenting system for this !), you have to select your 'child' layer (the one that will have the springy expressions) first, then select the 'parent' one as the second selected item, before clicking this button.");
            } else {
                app.beginUndoGroup("Springy parent");
                if (!PARENT("Parent")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn[1].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("BEND Deformer\nThe selected layer will bend as a 'bow shape' if you move it (or another layer if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'), by keyframing the Transform Position property along the X or the Y axis.");
            } else {
                app.beginUndoGroup("Bend deformer");
                if (!BEND("Bend", "X", "Y")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn[2].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("SHEAR Deformer\nThe selected layer will slant in a subtle 'S shape' without touching the base (bottom side) or the right border, like if these parts were 'sticking' to the ground, as soon as you move it (or another layer if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'), by keyframing the Transform Position property along the X or the Y axis.");
            } else {
                app.beginUndoGroup("Shear deformer");
                if (!SHEAR("Shear", "X", "Y")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn[3].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("SQUASH AND STRETCH Deformer\nThe selected layer will automatically squash and stretch (using a combination of the Transform Scale effect, and the Warp Bulge one), if you move it (or another layer if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'),\nby keyframing the Transform Position property along the X or the Y axis.");
            } else {
                app.beginUndoGroup("Squash and stretch deformer");
                if (!SQUASH_AND_STRETCH("Squash and Stretch", "X", "Y")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn[4].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("JIGGLE Deformer\nThe selected layer will deform like a soft body object if you move it, by keyframing the Transform Position property along the X or the Y axis. It entirely relies on the 'Puppet' effect, so make sure you have created some Puppet Pins with the Puppet Tool on your selected layer before clicking on this button. A dialog box will then pop-up and offers you 2 possibilies :\n\n1. The 1st one is to choose to make all the existing puppet pins act like jiggling ones ; just click 'YES' to do so (be careful since it could slow down your project due to the lot of used expressions).\n\n2. The 2nd option - available after having clicked 'NO' - is to select only the needed puppet pins, and to re-click on the button as explained in the dialog box.\n\nDo not forget to let at least one pin 'rigid' (i.e. without any jiggling effect) or to add some weight variations on a few of them (by playing with their MAX value in the CTRL Layer) for a better simulation !");
            } else {
                app.beginUndoGroup("Jiggle deformer");
                if (!JIGGLE("Jiggle")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn[5].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("BULGE Deformer\nThe selected layer will bulge as a 'pillow shape' if you rescale it (or another layer if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'), by keyframing the Transform Scale property along the X or the Y axis.");
            } else {
                app.beginUndoGroup("Bulge deformer");
                if (!BULGE("Bulge", "X", "Y")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn[6].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("TWIST Deformer\nThe selected layer will twist as a 'whirl shape' if you turn it (or another layer if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'), by keyframing the Transform Rotation property.\nTo make the effect more visible, you can either play with the 'Twist MAX' value on the Springy constraint CTRL layer, or with the 'Source Layer Size' in the Layer's Springy Deformers CTRL effect itself (these Source Layer Size values can be also set up, for both the X and the Y axis independantly, in the dialog box that pops up after having clicked on the button).");
            } else {
                app.beginUndoGroup("Twist deformer");
                if (!TWIST("Twist")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn[7].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("LIQUID Deformer\nThe selected layer will act as a 'liquid' object, using a combination of the Turbulences and the Transform Rotation effect, just by moving it (or another layer if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'), and keyframing the Transform Position property along the X or the Y axis. The Transform Rotation property can be animated as well, and the level of the liquid will try to remain as horizontal as possible.\nHere are the steps to ensure the best result :\n\n1. First select the layer that will be the liquid itself\n\n2. Then select the 2nd layer that you want to become your 'container' (e.g. a closed bottle shape)\n3. And click on this button.\n\nTIP : You can hold-down the SHIFT key while pressing the button, it will automaticaly create a cool bubbling effect on your liquid as well !");
            } else {
                app.beginUndoGroup("Liquid deformer");
                if (!LIQUID("Liquid")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn[8].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("CUSTOM Deformer\nThis one works a bit differently compared to the other deformers. Indeed, you can't select a layer to make it work ; you have to select one single property from any Effect instead. Moreover, this selected property has to be a numeric value (checkbox, dropdown lists, levels effect... won't work) that only has one single dimension (arrays of 2, 3 or more dimensions, like 'position','scale', 'color'... won't be accepted). Keep in mind that your property should be able to be linked to a 'slider' expression control (an angle or a percentage for instance would work).\n\nOnce you have selected your property and clicked the button, a dialog box will prompt you to type in the property and its axis that you want your custom springy property to be base on, in a prefefined format like PX (for Position on X axis), SY (for Scale on Y axis) or 'R' (for 2D RotaTion).\n\nDepending of which property you enter your custom springy property will animate while moving, rescaling or rotating along the defined axis.\n\nTIP : You can hold-down the SHIFT key while pressing the button, it will prompy you to enter a custom name and a custom value for your custom slider control (otherwise, the name of the slider will be the same name as the selected Effect's property).");
            } else {
                app.beginUndoGroup("Custom springy deformer");
                if (!CUSTOM("Custom")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn[9].onClick = function() {
            HELP_AND_INFO();
        };
        btn2[0].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("PARENT Constraint\nThe selected layer will follow its own keyframed motion or the motion from another layer (if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'), with a nice elastic delay.\n\nIf you want to keep the orginal motion from the selected layer as the source for the springy motion, just select this animated layer, then click the button.\n\nBut if you want to make a 'child' layer springy follow the motion from a 'parent' layer (DO NOT use the AE's parenting system for this !), you have to select your 'child' layer (the one that will have the springy expressions) first, then select the 'parent' one as the second selected item, before clicking this button.");
            } else {
                app.beginUndoGroup("Springy parent");
                if (!PARENT("Parent")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn2[1].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("BEND Deformer\nThe selected layer will bend as a 'bow shape' if you move it (or another layer if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'), by keyframing the Transform Position property along the X or the Y axis.");
            } else {
                app.beginUndoGroup("Bend deformer");
                if (!BEND("Bend", "X", "Y")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn2[2].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("SHEAR Deformer\nThe selected layer will slant in a subtle 'S shape' without touching the base (bottom side) or the right border, like if these parts were 'sticking' to the ground, as soon as you move it (or another layer if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'), by keyframing the Transform Position property along the X or the Y axis.");
            } else {
                app.beginUndoGroup("Shear deformer");
                if (!SHEAR("Shear", "X", "Y")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn2[3].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("SQUASH AND STRETCH Deformer\nThe selected layer will automatically squash and stretch (using a combination of the Transform Scale effect, and the Warp Bulge one), if you move it (or another layer if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'),\nby keyframing the Transform Position property along the X or the Y axis.");
            } else {
                app.beginUndoGroup("Squash and stretch deformer");
                if (!SQUASH_AND_STRETCH("Squash and Stretch", "X", "Y")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn2[4].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("JIGGLE Deformer\nThe selected layer will deform like a soft body object if you move it, by keyframing the Transform Position property along the X or the Y axis. It entirely relies on the 'Puppet' effect, so make sure you have created some Puppet Pins with the Puppet Tool on your selected layer before clicking on this button. A dialog box will then pop-up and offers you 2 possibilies :\n\n1. The 1st one is to choose to make all the existing puppet pins act like jiggling ones ; just click 'YES' to do so (be careful since it could slow down your project due to the lot of used expressions).\n\n2. The 2nd option - available after having clicked 'NO' - is to select only the needed puppet pins, and to re-click on the button as explained in the dialog box.\n\nDo not forget to let at least one pin 'rigid' (i.e. without any jiggling effect) or to add some weight variations on a few of them (by playing with their MAX value in the CTRL Layer) for a better simulation !");
            } else {
                app.beginUndoGroup("Jiggle deformer");
                if (!JIGGLE("Jiggle")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn2[5].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("BULGE Deformer\nThe selected layer will bulge as a 'pillow shape' if you rescale it (or another layer if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'), by keyframing the Transform Scale property along the X or the Y axis.");
            } else {
                app.beginUndoGroup("Bulge deformer");
                if (!BULGE("Bulge", "X", "Y")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn2[6].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("TWIST Deformer\nThe selected layer will twist as a 'whirl shape' if you turn it (or another layer if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'), by keyframing the Transform Rotation property.\nTo make the effect more visible, you can either play with the 'Twist MAX' value on the Springy constraint CTRL layer, or with the 'Source Layer Size' in the Layer's Springy Deformers CTRL effect itself (these Source Layer Size values can be also set up, for both the X and the Y axis independantly, in the dialog box that pops up after having clicked on the button).");
            } else {
                app.beginUndoGroup("Twist deformer");
                if (!TWIST("Twist")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn2[7].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("LIQUID Deformer\nThe selected layer will act as a 'liquid' object, using a combination of the Turbulences and the Transform Rotation effect, just by moving it (or another layer if you select another one in the Spring Constraint CTRL effect's 'Inherit motion from...'), and keyframing the Transform Position property along the X or the Y axis. The Transform Rotation property can be animated as well, and the level of the liquid will try to remain as horizontal as possible.\nHere are the steps to ensure the best result :\n\n1. First select the layer that will be the liquid itself\n\n2. Then select the 2nd layer that you want to become your 'container' (e.g. a closed bottle shape)\n3. And click on this button.\n\nTIP : You can hold-down the SHIFT key while pressing the button, it will automaticaly create a cool bubbling effect on your liquid as well !");
            } else {
                app.beginUndoGroup("Liquid deformer");
                if (!LIQUID("Liquid")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn2[8].onClick = function() {
            var touches = detect();
            if (touches.indexOf("alt") != -1) {
                alert("CUSTOM Deformer\nThis one works a bit differently compared to the other deformers. Indeed, you can't select a layer to make it work ; you have to select one single property from any Effect instead. Moreover, this selected property has to be a numeric value (checkbox, dropdown lists, levels effect... won't work) that only has one single dimension (arrays of 2, 3 or more dimensions, like 'position','scale', 'color'... won't be accepted). Keep in mind that your property should be able to be linked to a 'slider' expression control (an angle or a percentage for instance would work).\n\nOnce you have selected your property and clicked the button, a dialog box will prompt you to type in the property and its axis that you want your custom springy property to be base on, in a prefefined format like PX (for Position on X axis), SY (for Scale on Y axis) or 'R' (for 2D RotaTion).\n\nDepending of which property you enter your custom springy property will animate while moving, rescaling or rotating along the defined axis.\n\nTIP : You can hold-down the SHIFT key while pressing the button, it will prompy you to enter a custom name and a custom value for your custom slider control (otherwise, the name of the slider will be the same name as the selected Effect's property).");
            } else {
                app.beginUndoGroup("Custom springy deformer");
                if (!CUSTOM("Custom")) {
                    return false;
                }
                app.endUndoGroup();
            }
        };
        btn2[9].onClick = function() {
            HELP_AND_INFO();
        };
        mainPalette.layout.layout(true);
        mainPalette.layout.resize();
        mainPalette.onResizing = mainPalette.onResize = function() {
            content.orientation = mainPalette.size.width > mainPalette.size.height ? "row" : "column";
            content2.orientation = mainPalette.size.width > mainPalette.size.height ? "row" : "column";
            if (mainPalette.size.width > 150 && mainPalette.size.width < mainPalette.size.height) {
                content2.visible = true;
                content.visible = false;
            } else {
                content.visible = true;
                content2.visible = false;
            }
            mainPalette.layout.resize();
        };
        if (!(mainPalette instanceof Panel)) {
            mainPalette.show();
        }
    }
    var version = "1.01";
    var scriptName = "Springy FX";
        SpringyFX(thisObj);
}


SpringyFX_Main(this);